from pymol import cmd

def parseDistObj(obj):
    if (obj[5][0][3][10] != 1): # 'show dashed' flag
        return ""
    points = obj[5][2][0][1]
    ret = []
    for i in range(len(points) / 6):
        ret.append([(points[i * 6], points[i * 6 + 1], points[i * 6 + 2]),
                     (points[i * 6 + 3], points[i * 6 + 4], points[i * 6 + 5])])
    return ret

def list_dist():
    names = cmd.get_session()['names']

    dist_pairs = []
    for obj in names:
        if (obj == None):
            continue
        if (obj[1] == 0 and obj[4] == 4):
            dist_pairs += parseDistObj(obj)

    namespace = {'dict': {}, 'a': 1}
    dict = {}
    cmd.iterate_state(1, 'all', 'dict[x,y,z] = chain+"/"+resn+"`"+resi+"/"+name' , space=namespace)
    dict = namespace['dict']
    #print dict
    atomSel = ""
    resSel = ""
    for pair in dist_pairs:
        first = dict.get(pair[0], '?')  # pair[0 or 1] => (x,y,z) coordinates of the distance end points
        second = dict.get(pair[1], '?')
        print first + " - " + second
        dummy = first.split('/')
        firstRes = dummy[0] + '/' + dummy[1] + '/'
        dummy = second.split('/')
        secondRes = dummy[0] + '/' + dummy[1] + '/'
	if len(atomSel) > 0:
		atomSel += " or "
	if len(resSel) > 0:
		resSel += " or "
        atomSel += first + " or " + second
        resSel += firstRes + " or " + secondRes
    print atomSel
    print resSel
    cmd.select("distAtoms", atomSel)
    cmd.select("distRes", resSel)

cmd.extend('list_dist', list_dist)
